diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/Receiver.java AndroidSource/frameworks/base/services/java/com/android/server/remote/Receiver.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/Receiver.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/Receiver.java	2016-09-26 18:10:33.627717490 +0900
@@ -0,0 +1,575 @@
+
+package com.android.server.remote;
+
+import java.io.IOException;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.net.Socket;
+import java.nio.ByteBuffer;
+import java.util.Arrays;
+
+import android.app.ActivityThread;
+import android.app.Instrumentation;
+import android.content.ComponentName;
+import android.content.Context;
+import android.content.Intent;
+import android.graphics.Point;
+import android.hardware.input.IInputManager;
+import android.hardware.input.InputManager;
+import android.location.ILocationManager;
+import android.location.Location;
+import android.location.LocationManager;
+import android.media.AudioFormat;
+import android.media.AudioManager;
+import android.media.AudioTrack;
+import android.media.MediaCodec;
+import android.media.MediaFormat;
+import android.os.Binder;
+import android.os.Bundle;
+import android.os.IVibratorService;
+import android.os.ServiceManager;
+import android.os.SystemClock;
+import android.os.SystemVibrator;
+import android.os.Vibrator;
+import android.service.remote.IRemoteService;
+import android.service.remote.RemoteRequest;
+import android.service.remote.SdPackage;
+import android.util.Log;
+import android.view.Display;
+import android.view.KeyEvent;
+import android.view.MotionEvent;
+import android.view.WindowManager;
+
+public class Receiver implements Runnable {
+    private static final String TAG = "Receiver";
+
+    private Socket clientSocket;
+    private ObjectOutputStream outToClient;
+    private ObjectInputStream inFromClient;
+    private int hashValue;
+    private int sourceDevice;
+
+    // private ObjectOutputStream
+
+    private final Context mContext;
+    private final String mPackageName;
+    private final IVibratorService mService;
+
+    private SystemVibrator mVibratorService;
+    private Vibrator mVibrator;
+
+    private final IInputManager mInputService;
+    private final Instrumentation mInstrumentation;
+    private final ILocationManager mLocationManager;
+    private final IRemoteService mRemoteService;
+
+    // //////////////////////////////////////////////////////
+    private MediaFormat format;
+    private MediaCodec codec;
+    private AudioTrack audioTrack;
+    // variables of format
+    private String mime = "";
+    private int sampleRate = 0, channels = 0, bitrate = 0;
+    private long duration = 0;
+    ByteBuffer[] codecInputBuffers;
+    ByteBuffer[] codecOutputBuffers;
+    // decode start
+    final long TIMEOUT_US = 5000;
+    MediaCodec.BufferInfo info = new MediaCodec.BufferInfo();
+    boolean sawInputEOS = false;
+    boolean sawOutputEOS = false;
+    int noOutputCounter = 0;
+    int noOutputCounterLimit = 10;
+    private int test = 0;
+
+    boolean stop = false;
+    long presentationTimeUs = 0;
+    int sampleSize = 0;
+    // /////////////////////////////////////////////
+    
+    private int Xdefault;
+	private int Ydefault;
+
+    // private Object input = null;;
+    private Location location = new Location("");
+
+    // Native Functions
+    native void sendRemoteEvent(int type, int sensor, float[] values, int accuracy, long timestamp,
+            int sourceDevice);
+
+    public Receiver(Context context, Socket clientSocket, int _sourceDevice) {
+        mContext = context;
+        mPackageName = ActivityThread.currentPackageName();
+        mService = IVibratorService.Stub.asInterface(ServiceManager
+                .getService("vibrator"));
+
+        mVibratorService = new SystemVibrator(mContext);
+
+        mInputService = IInputManager.Stub.asInterface(ServiceManager.getService("input"));
+        mInstrumentation = new Instrumentation();
+
+        mLocationManager = ILocationManager.Stub.asInterface(ServiceManager.getService("location"));
+        
+        mRemoteService = IRemoteService.Stub.asInterface(ServiceManager.getService(Context.REMOTE_SERVICE));
+
+        this.clientSocket = clientSocket;
+        hashValue = clientSocket.getInetAddress().getHostAddress().hashCode();
+        this.sourceDevice = _sourceDevice;
+
+        WindowManager wm = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
+		Display display = wm.getDefaultDisplay();
+		Point size = new Point();
+		display.getSize(size);
+		
+		Xdefault = size.x;
+		Ydefault = size.y;
+        
+        Log.d(TAG, "request from: "
+                + this.clientSocket.getInetAddress().getHostAddress());
+
+        try {
+            outToClient = new ObjectOutputStream(
+                    this.clientSocket.getOutputStream());
+            inFromClient = new ObjectInputStream(
+                    this.clientSocket.getInputStream());
+        } catch (IOException e) {
+            e.printStackTrace();
+        }
+    }
+
+    public void terminate() 
+    {
+        
+    }
+
+    @Override
+    public void run() {
+        // TODO Auto-generated method stub
+        try {
+            while (!Thread.currentThread().isInterrupted())
+            {
+                Object input = inFromClient.readObject();
+               
+                // request for resources
+                if(input instanceof ResourceRequest)
+                {
+                	// ask RemoteService whether this device is allowed for the resources   
+                	ResourceRequest rr = (ResourceRequest)input;
+                	Log.d(TAG, "Requested: " + Arrays.toString(rr.getRequestedResources()));
+                	RemoteService.waitForResponse.put(clientSocket.getInetAddress().getHostAddress(), outToClient);
+                	mRemoteService.isAllowedForResource(rr.getDeviceName(), clientSocket.getInetAddress().getHostAddress(), rr.getRequestedResources());
+                	//outToClient.writeObject(test);
+                }
+                else if (input instanceof String) {
+                    Log.d(TAG, "String: " + input.toString());
+                    if (input.toString().equals("Hello")) {
+                        Log.d(TAG, "just got Hellooo from client"
+                                + RemoteService.mSensorHandles.toString());
+                        outToClient.writeObject("Gooooood");
+                    }
+                }
+                else if (input instanceof RemoteRequest) {
+                    RemoteRequest request = (RemoteRequest) input;
+
+                    // Log.d(TAG, "Request: " + request.toString());
+
+                    // Handle Request Here!
+                    final long origId = Binder.clearCallingIdentity();
+
+                    try
+                    {
+                        if (request.getType().equalsIgnoreCase("systemcall")) {
+                            if (request.getMethod().compareTo("vibrate") == 0)
+                            {
+//                                Log.d(TAG, "vibrated" + sourceDevice);
+                                mVibrator = (Vibrator) mContext.getSystemService(Context.VIBRATOR_SERVICE);
+                                mVibrator.vibrate((Long) request.getPara().get(0));
+                                Log.d(TAG, "vibrated: " + sourceDevice);
+//                                mVibratorService.vibrate((Long) request.getPara().get(0));
+                            }
+                            else if (request.getMethod().compareTo("vibrate2") == 0)
+                            {
+                                mVibrator = (Vibrator) mContext.getSystemService(Context.VIBRATOR_SERVICE);
+                                mVibrator.vibrate((long[]) request.getPara().get(0),
+                                        (Integer) request.getPara().get(1));
+//                                mVibratorService.vibrate((long[]) request.getPara().get(0),
+//                                                (Integer) request.getPara().get(1));
+                            }
+                        }
+                        else if (request.getType().equals("RemoteMusic"))
+                        {
+                            Log.d(TAG, "you are in RemoteRequest, in if RemoteMusic");
+                            RemoteRequest rr = (RemoteRequest) input;
+                            format = new MediaFormat();
+                            try
+                            {
+                                // format = MediaFormat.createAudioFormat(mime,
+                                // sampleRate,
+                                // channels);
+                                // format = ee.getTrackFormat(0);
+                                Log.d(TAG, "the mime is  "
+                                        + (String) rr.getPara().get(0));
+                                format.setString(MediaFormat.KEY_MIME,
+                                        mime = (String) rr.getPara().get(0));
+                                format.setInteger(MediaFormat.KEY_SAMPLE_RATE,
+                                        sampleRate = (Integer) rr.getPara()
+                                                .get(1));
+                                format.setInteger(
+                                        MediaFormat.KEY_CHANNEL_COUNT,
+                                        channels = (Integer) rr.getPara()
+                                                .get(2));
+                                format.setLong(MediaFormat.KEY_DURATION,
+                                        duration = (Long) rr.getPara().get(3));
+
+                            } catch (Exception e)
+                            {
+                                Log.e(TAG,
+                                        "Reading format parameters exception:"
+                                                + e.getMessage());
+                            }
+                            codec = MediaCodec.createDecoderByType("audio/mpeg");
+                            codec.configure(format, null, null, 0);
+                            codec.start();
+
+                            codecInputBuffers = codec.getInputBuffers();
+                            codecOutputBuffers = codec.getOutputBuffers();
+
+                            int channelConfiguration = 0;
+                            if (channels == 1)
+                                channelConfiguration = AudioFormat.CHANNEL_OUT_MONO;
+                            else
+                                channelConfiguration = AudioFormat.CHANNEL_OUT_STEREO;
+
+                            int minSize = AudioTrack.getMinBufferSize(sampleRate,
+                                    channelConfiguration,
+                                    AudioFormat.ENCODING_PCM_16BIT);
+                            audioTrack = new AudioTrack(AudioManager.STREAM_MUSIC,
+                                    sampleRate, channelConfiguration,
+                                    AudioFormat.ENCODING_PCM_16BIT, minSize,
+                                    AudioTrack.MODE_STREAM);
+                            // feeding
+                            audioTrack.play();
+
+                            Log.d(TAG, "the codec is waiting for you");
+                            test = 0;
+                        }
+                        // music stop
+                        else if (request.getType().equals("StopMusic")) {
+                            Log.d(TAG, "stopping...");
+
+                            if (codec != null)
+                            {
+                                codec.stop();
+                                codec.release();
+                                codec = null;
+                            }
+                            if (audioTrack != null)
+                            {
+                                audioTrack.flush();
+                                audioTrack.release();
+                                audioTrack = null;
+                            }
+                            Log.d(TAG, "music play is done");
+
+                        }
+
+                        // video streaming
+                        else if (request.getType().equalsIgnoreCase("video_streaming"))
+                        {
+                            Log.d(TAG, "11111111111");
+                            if (request.getMethod().equalsIgnoreCase("get_surface")) {
+                                Log.d(TAG, "2222222222");
+                                ComponentName compName = new ComponentName(
+                                        "com.example.surfaceprovider"
+                                        , "com.remote.surfaceprovider.SurfaceProvider");
+                                
+                                Intent intent = new Intent(Intent.ACTION_MAIN);
+                                intent.addCategory("android.intent.category.VIDEO_STREAMING");
+                                intent.setComponent(compName);
+                                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+                                
+                                int port = (Integer) request.getPara().get(1);
+                                Log.d(TAG, request.toString() + "  " + port);
+                                intent.putExtra("mode", "video");
+                                intent.putExtra("dcslab", port);
+                                mContext.startActivity(intent);
+
+                                // Intent intent =
+                                // context.getPackageManager().getLaunchIntentForPackage("ParkageName");
+                                // startActivity(intent);
+                            }
+                        }
+                        else if(request.getType().equalsIgnoreCase("request")){
+                            if(request.getMethod().equalsIgnoreCase("motion")){
+                                mRemoteService.connectToServer(clientSocket.getInetAddress().getHostAddress());
+                            }
+                            else if(request.getMethod().equalsIgnoreCase("dummyApp")){
+                            	Log.d(TAG, "HELLO");
+                                ComponentName compName = new ComponentName(
+                                        "com.example.surfaceprovider"
+                                        , "com.remote.surfaceprovider.SurfaceProvider");
+                                
+                                Intent intent = new Intent(Intent.ACTION_MAIN);
+                                intent.addCategory("android.intent.category.VIDEO_STREAMING");
+                                intent.setComponent(compName);
+                                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
+                                                                
+                                intent.putExtra("mode", "dummyApp");
+                                
+                                mContext.startActivity(intent);
+                            }
+                        }
+                    } finally {
+                        Binder.restoreCallingIdentity(origId);
+                    }
+                } else if (input instanceof RemoteMotionEvent) {
+                    // MotionEvent event = (MotionEvent)input;
+                    RemoteMotionEvent rme = (RemoteMotionEvent) input;
+
+                    // Log.d(TAG, "RemoteMotionEvent: " + rme.toString());
+
+                    /*
+                     * MotionEvent event = MotionEvent.obtain(
+                     * SystemClock.uptimeMillis(), SystemClock.uptimeMillis(),
+                     * rme.getAction(), rme.getX() *
+                     * RemoteRequestHandler.Xdefault, rme.getY() *
+                     * RemoteRequestHandler.Ydefault, 0);
+                     */
+                    /*
+                     * MotionEvent event = MotionEvent.obtain(rme.getDownTime(),
+                     * rme.getEventTime(), rme.getAction(), rme.getX()
+                     * RemoteRequestHandler.Xdefault, rme.getY()
+                     * RemoteRequestHandler.Ydefault, 0);
+                     * event.setSource(rme.getSource());
+                     */
+                    
+                    MotionEvent event = MotionEvent.obtain(
+                            SystemClock.uptimeMillis(),
+                            SystemClock.uptimeMillis(),
+                            rme.getAction(),
+                            rme.getX() * Xdefault,
+                            rme.getY() * Ydefault, sourceDevice << 24);
+
+                    event.setSource(rme.getSource());
+
+//                    Log.d("TouchLatency", "TouchLatency, Node: " + sourceDevice);
+/*                    MotionEvent event;
+                    if (sourceDevice != 1) {
+                        event = MotionEvent.obtain(SystemClock.uptimeMillis(),
+                                SystemClock.uptimeMillis(), rme.getAction(), 500, 500, 0);
+                        event.setSource(rme.getSource());
+                    }
+                    else {
+                        event = MotionEvent.obtain(
+                                SystemClock.uptimeMillis(),
+                                SystemClock.uptimeMillis(),
+                                (rme.getAction() + (sourceDevice << 24)),
+                                rme.getX() * RemoteRequestHandler.Xdefault,
+                                rme.getY() * RemoteRequestHandler.Ydefault, 0);
+
+                        event.setSource(rme.getSource());
+                    }*/
+                    try
+                    {
+                        if (!mInputService.injectInputEvent(event,
+                                InputManager.INJECT_INPUT_EVENT_MODE_WAIT_FOR_RESULT))
+                        {
+                            Log.d(TAG, "FAIL!!!!!");
+                        }
+                    } finally
+                    {
+                        event.recycle();
+                    }
+                }
+                /*
+                 * else if(input instanceof RemoteKeyEvent) { }
+                 */
+
+                else if (input instanceof RemoteKeyEvent)
+                {
+                    RemoteKeyEvent rke = (RemoteKeyEvent) input;
+                    // Log.d(TAG, rke.toString());
+
+                    mInstrumentation.sendKeyDownUpSync(rke.getCode());
+                    if (rke.getAction() == KeyEvent.ACTION_DOWN) {
+                        Log.d("KeyLatency", "KeyLatency - server: " + sourceDevice);
+                    }
+                    /*
+                     * KeyEvent event = new KeyEvent(rke.getAction(),
+                     * rke.getCode()); event.setSource(rke.getSource()); try {
+                     * if (!mInputService.injectInputEvent(event,
+                     * InputManager.INJECT_INPUT_EVENT_MODE_ASYNC)) { Log.d(TAG,
+                     * "FAIL!!!!!"); } } finally { event.recycle(); }
+                     */
+                }
+                else if (input instanceof RemoteSensorEvent)
+                {
+                    RemoteSensorEvent rse = (RemoteSensorEvent) input;
+                    // Log.d(TAG, rse.toString());
+                    // Log.d(TAG, )
+
+                    //Log.d(TAG, rse.toString());
+                    
+                    sendRemoteEvent(rse.getType(),
+                    		RemoteService.mSensorHandles.get(rse.getType()),
+                    		rse.getValues(),
+                    		rse.getAccuracy(),
+                    		rse.getTimestamp(),
+                    		sourceDevice);
+
+                    // proximity
+                   /* sendRemoteEvent(21, 21, rse.getValues(),
+                            rse.getAccuracy(),
+                            rse.getTimestamp(),
+                            sourceDevice);*/
+                    //Log.d(TAG, rse.toString() + "source" + sourceDevice);
+
+                }
+
+                else if (input instanceof SdPackage) {
+                    // Log.d(TAG,
+                    // "music play start from request handler (SdPackage)");
+                    noOutputCounter++;
+                    // read a buffer before feeding it to the decoder
+                    if (!sawInputEOS) {
+                        int inputBufIndex = codec.dequeueInputBuffer(TIMEOUT_US);
+                        if (inputBufIndex >= 0) {
+                            ByteBuffer dstBuf = codecInputBuffers[inputBufIndex];
+
+                            SdPackage sdp = (SdPackage) input;
+                            // Log.i(TAG, sdp.toString());
+
+                            sampleSize = sdp.getSampleSize();
+                            byte[] temp_bytearray = new byte[sampleSize];
+                            temp_bytearray = sdp.getSampleData();
+                            // Log.i(TAG, Arrays.toString(temp_bytearray));
+                            dstBuf.clear();
+                            // dstBuf = ByteBuffer.wrap(temp_bytearray);
+                            dstBuf.put(temp_bytearray);
+                            presentationTimeUs = sdp.getPresentationTime();
+
+                            codec.queueInputBuffer(inputBufIndex, 0,
+                                    sampleSize, presentationTimeUs, 0);
+
+                            // Log.d(TAG, "client: queued to inputbuffer " +
+                            // inputBufIndex);
+                            // if (!sawInputEOS) //remote
+                            // extractor.advance(); //remote
+
+                        } else {
+                            // Log.e(TAG, "client: inputBufIndex " +
+                            // inputBufIndex);
+                        }
+                    } // !sawInputEOS
+
+                    // ///////////////////////////////////////////////////////
+                    // MediaCodecInfo df = codec.getCodecInfo();
+                    // byte[] dddd = new byte[8192];
+                    // for(int i=0;i<codecInputBuffers.length;i++){
+                    // for(int j=0;j<codecInputBuffers[i].limit();j++){
+                    // dddd[j] = codecInputBuffers[i].get(j);
+                    // }
+                    // Log.d("debugging", Arrays.toString(dddd));
+                    // }
+
+                    // /////////////////////////////////////////////////////
+
+                    // for (int i = 0; i < codecOutputBuffers.length; i++) {
+                    // Log.d(TAG, String.valueOf(codecOutputBuffers[i]
+                    // .remaining()));
+                    // }
+
+                    // decode to PCM and push it to the AudioTrack player
+                    int res = codec.dequeueOutputBuffer(info, 5000);
+
+                    if (res >= 0) {
+                        int outputBufIndex = res;
+                        ByteBuffer buf = codecOutputBuffers[outputBufIndex];
+                        // ByteBuffer buf =
+                        // codec.getOutputBuffer(outputBufIndex);
+
+                        final byte[] chunk = new byte[info.size];
+                        buf.get(chunk);
+                        buf.clear();
+                        if (chunk.length > 0) {
+                            audioTrack.write(chunk, 0, chunk.length);
+                        }
+
+                        codec.releaseOutputBuffer(outputBufIndex, false);
+
+                        if ((info.flags & MediaCodec.BUFFER_FLAG_END_OF_STREAM) != 0) {
+                            Log.d(TAG, "saw output EOS.");
+                            sawOutputEOS = true;
+                        }
+                    } else if (res == MediaCodec.INFO_OUTPUT_BUFFERS_CHANGED) {
+                        Log.d(TAG,
+                                "oh! information of output buffer has been changed");
+                        codecOutputBuffers = codec.getOutputBuffers();
+                        Log.d(TAG, "output buffers have changed.");
+                    } else if (res == MediaCodec.INFO_OUTPUT_FORMAT_CHANGED) {
+                        Log.d(TAG, "oh! the output format changed!");
+                        MediaFormat oformat = codec.getOutputFormat();
+                        Log.d(TAG, "output format has changed to "
+                                + oformat);
+                        Log.d("AudioLatency", "Bravo!!! thank you!! JG and HB !!!!!!! I love you !!");
+                    } else {
+                        Log.d(TAG, "dequeueOutputBuffer returned " + res);
+                    }
+
+                    // Log.d("TAG", String.valueOf(noOutputCounter));
+
+                }
+                else if (input instanceof RemoteLocation)
+                {
+                    RemoteLocation RL = (RemoteLocation) input;
+
+                    location = new Location("");
+
+                    // location.reset();
+                    // location.setProvider(RL.getProvider());
+                    location.setProvider(LocationManager.REMOTE_PROVIDER);
+                    // location.setTime(RL.getTime());
+                    location.setTime(System.currentTimeMillis());
+                    // location.setElapsedRealtimeNanos(RL.getElapsedRealtimeNanos());
+                    location.setElapsedRealtimeNanos(SystemClock.elapsedRealtimeNanos());
+                    location.setLatitude(RL.getLatitude());
+                    location.setLongitude(RL.getLongitude());
+
+                    if (RL.getAltitude() != 0.0f)
+                        location.setAltitude(RL.getAltitude());
+                    if (RL.getSpeed() != 0.0f)
+                        location.setSpeed(RL.getSpeed());
+                    if (RL.getBearing() != 0.0f)
+                        location.setBearing(RL.getBearing());
+                    if (RL.getAccuracy() != 0.0f)
+                        location.setAccuracy(RL.getAccuracy());
+
+                    location.setExtras(RL.getExtras());
+                    location.setIsFromMockProvider(RL.isFromMockProvider());
+
+                    if (location.getExtras() != null)
+                        location.getExtras().putInt("SourceDevice", sourceDevice);
+                    else
+                    {
+                        Bundle bundle = new Bundle();
+                        bundle.putInt("SourceDevice", sourceDevice);
+                        location.setExtras(bundle);
+                    }
+
+                    mLocationManager.reportLocation(location, false);
+                }
+                else
+                    Log.d(TAG, "What is this??");
+
+                // input.
+            }
+
+            clientSocket.close();
+            inFromClient.close();
+            outToClient.close();
+            
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+    }
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteKeyEvent.java AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteKeyEvent.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteKeyEvent.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteKeyEvent.java	2016-02-16 20:32:50.000000000 +0900
@@ -0,0 +1,34 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+public class RemoteKeyEvent implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+
+	private final int action;
+	private final int code;
+	private final int source;
+	
+	public RemoteKeyEvent(int action, int code, int source)
+	{
+		this.action = action;
+		this.code = code;
+		this.source = source;
+	}
+	
+	public int getAction()
+	{
+		return action;
+	}
+	
+	public int getCode()
+	{
+		return code;
+	}
+	
+	public int getSource()
+	{
+		return source;
+	}
+}
\ No newline at end of file
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteLocation.java AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteLocation.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/RemoteLocation.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/RemoteLocation.java	2016-02-16 20:32:54.000000000 +0900
@@ -0,0 +1,93 @@
+package com.android.server.remote;
+
+import java.io.Serializable;
+
+import android.location.Location;
+import android.os.Bundle;
+
+public class RemoteLocation implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+	
+	private final String mProvider;
+    private final long mTime;
+    private final long mElapsedRealtimeNanos;
+    private final double mLatitude;
+    private final double mLongitude;
+    private final double mAltitude;
+    private final float mSpeed;
+    private final float mBearing;
+    private final float mAccuracy;
+    private final Bundle mExtras;
+    private final boolean mIsFromMockProvider;
+    
+    public RemoteLocation(Location l)
+    {
+    	mProvider = l.getProvider();
+        mTime = l.getTime();
+        mElapsedRealtimeNanos = l.getElapsedRealtimeNanos();
+        mLatitude = l.getLatitude();
+        mLongitude = l.getLongitude();
+        mAltitude = l.getAltitude();
+        mSpeed = l.getSpeed();
+        mBearing = l.getBearing();
+        mAccuracy = l.getAccuracy();
+        mExtras = (l.getExtras() == null) ? null : new Bundle(l.getExtras());
+        mIsFromMockProvider = l.isFromMockProvider();
+    }
+    
+    public String getProvider()
+    {
+    	return mProvider;
+    }
+
+	public long getTime()
+	{
+		return mTime;
+	}
+
+	public long getElapsedRealtimeNanos()
+	{
+		return mElapsedRealtimeNanos;
+	}
+
+	public double getLatitude()
+	{
+		return mLatitude;
+	}
+
+	public double getLongitude()
+	{
+		return mLongitude;
+	}
+
+	public double getAltitude()
+	{
+		return mAltitude;
+	}
+
+	public float getSpeed()
+	{
+		return mSpeed;
+	}
+
+	public float getBearing()
+	{
+		return mBearing;
+	}
+
+	public float getAccuracy()
+	{
+		return mAccuracy;
+	}
+
+	public Bundle getExtras()
+	{
+		return mExtras;
+	}
+
+	public boolean isFromMockProvider()
+	{
+		return mIsFromMockProvider;
+	}
+}
